#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ld long double
const ld INF = 1e18;

void solve();

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int qwerty = 1;
    // cin >> qwerty;
    while (qwerty--) {
        solve();
    }
}

struct Point {
    ld x, y;

    Point(ld a, ld b) {
        x = a, y = b;
    }
};

struct line {
    ld a, b, c;

    line(ld ax, ld ay, ld bx, ld by) {
        a = ay - by;
        b = bx - ax;
        c = ay * (ax - bx) + ax * (by - ay);
    }
};

ld dist(Point a, Point b) {
    return sqrtl((a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y));
}

Point per(line l, Point a) {
    return {(l.b * (l.b * a.x - l.a * a.y) - l.a * l.c) / (l.a * l.a + l.b * l.b),
            (l.a * (-l.b * a.x + l.a * a.y) - l.b * l.c) / (l.a * l.a + l.b * l.b)};
}

ld dist_for_dp(line l, Point a, Point b) {
    Point firper = per(l, a);
    Point secper = per(l, b);
    ld fird = dist(firper, a);
    ld secd = dist(secper, b);
    ld distab = dist(a, b);
    if (abs(distab - sqrtl(dist(firper, secper) * dist(firper, secper) + (fird + secd) * (fird + secd))) < 1e-9) {
        return fird + secd + dist(firper, secper);
    }
    return dist(firper, secper) + abs(fird - secd);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    int sz = 1 << n;
    ld ans = INF;
    for (int q1 = 0; q1 < n; q1++) {
        for (int q2 = q1 + 1; q2 < n; q2++) {
            line l(a[q1].first, a[q1].second, a[q2].first, a[q2].second);
            vector<vector<ld>> dp(sz, vector<ld>(n, INF));
            for (int i = 0; i < n; i++) {
                dp[1 << i][i] = 0;
            }
            for (int i = 1; i < sz; i++) {
                for (int j = 0; j < n; j++) {
                    if (dp[i][j] == 0) continue;
                    if (i & (1 << j)) {
                        int now = i ^ (1 << j);
                        ld mn = INF;
                        for (int k = 0; k < n; k++) {
                            if (now & (1 << k)) {
                                Point fir(a[j].first, a[j].second);
                                Point sec(a[k].first, a[k].second);
                                mn = min(mn, dp[now][k] + dist_for_dp(l, fir, sec));
                            }
                        }
                        dp[i][j] = min(dp[i][j], mn);
                    }
                }
            }
            for (int j = 0; j < n; j++) {
                ans = min(ans, dp.back()[j]);
            }
        }
    }
    cout << fixed << setprecision(6);
    cout << ans;
}
